load('zmat');
zvec = zmat(:,1);
lncbyn = zmat(:,2);
zjvec = [4; 5; 6; 3; 2; 2.5; 3.5; 4.5; 5.5;	6.5; 2.25; 2.75];
K = 0.9;
n = numel(zvec);
m = numel(zjvec);
eta = zeros(n,m);
beta = 1.0/(300.0 * 8.617e-5);
BA = zeros(m,1);
BAprev = zeros(m,1);
for i=1:n
    for j=1:m
        eta(i,j) = -1*beta*K*(zvec(i,1)-zjvec(j,1))^2.0;
    end
end 
etamin = min(min(eta));
BF = zeros(n,1);
err = 1.0;
while err > 0.005
   BAmax = max(BA);
   BA = BA - BAmax;
    for i=1:n
        sumj = 0.0;
        for j=1:m
            sumj = sumj + exp(eta(i,j) + BA(j,1));
        end
        BF(i,1) = BAmax + log(sumj) - lncbyn(i,1);
    end
    BFmin = min(BF);
    
    BF = BF - BFmin;
    %min(BAprev)
    BAprev = BA + BAmax;
    %min(BAprev)
    for j=1:m
        sumi = 0.0;
        for i=1:n
            sumi = sumi + exp(eta(i,j)-BF(i,1));
        end
        BA(j,1) = BFmin - log(sumi);
    end
    err = norm(BA-BAprev)/norm(BAprev)
    BF = BF + BFmin;
end
plot(zvec,BF)